      subroutine alphaf
c calculates the integrals SS(u),ST(u),TT(u) in eq. (A23)
c from S.M.Flatte' and R.B.Stougton "Predictions of internal-wave
c effects on ocean acoustics coherence,travel-time variance,
c and intensity moments for very long-range propagation".
      integer steps
      real a1nsq,a2nsq,b1nsq(900),b2nsq(900),
     & ab1n(900),ab2n(900),sa1n(900),sa2n(900),sb1n(900),
     & sb2n(900),sc1n(900),sc2n(900)
      real ttf(900),stf(900),ssf(900)
      real wtsq(1000),wst(1000),wssq(1000)
      common/loops/nloops,itmin,rfrac
      common/rparm/rmax,steps,hstore,hlas
      common/ab/a1nsq,a2nsq,b1nsq,b2nsq,ab1n,ab2n,sa1n,sa2n,
     & sb1n,sb2n,sc1n,sc2n
      common/wints/wtsq,wst,wssq,wtsq0p,wst0p,wssq0p,loc
      common/falpha/ttf,stf,ssf
      n1=nloops+1
c nloops=number of full double-loops in ray propagation from source to receiver
c ttf(i)=TT(u); stf(i)=ST(u); ssf(i)=SS(u) in eq.(A23) for contribution from
c full doule-loop integrals
      ttf(1)=0.
      stf(1)=0.
      ssf(1)=0.
      if(nloops.eq.0) go to 99
      tt2=sa2n(1)*a1nsq
      tt5=sc2n(1)*a1nsq
      tt8=sb2n(1)*a1nsq
      st2=sa2n(1)*ab1n(1)
      st5=sc2n(1)*ab1n(1)
      st8=sb2n(1)*ab1n(1)
      ss2=sa2n(1)*b1nsq(1)
      ss5=sc2n(1)*b1nsq(1)
      ss8=sb2n(1)*b1nsq(1)
      wtsqpr=wtsq(steps)-wtsq0p
      wstpr=wst(steps)-wst0p
      wssqpr=wssq(steps)-wssq0p
      tt1=0.
      tt4=0.
      tt7=0.
      st1=0.
      st4=0.
      st7=0.
      ss1=0.
      ss4=0.
      ss7=0.
      tt3=0.
      tt6=0.
      tt9=0.
      st3=0.
      st6=0.
      st9=0.
      ss3=0.
      ss6=0.
      ss9=0.
      ttf(1)=tt2*wssq0p+2.*tt5*wst0p+tt8*wtsq0p
      stf(1)=st2*wssq0p+2.0*st5*wst0p+st8*wtsq0p
      ssf(1)=ss2*wssq0p+2.0*ss5*wst0p+ss8*wtsq0p
      if(nloops.eq.1) go to 30
      tt3=(sa2n(1)-a2nsq)*a1nsq
      tt6=(sc2n(1)-ab2n(nloops+1))*a1nsq
      tt9=(sb2n(1)-b2nsq(nloops+1))*a1nsq
      st3=(sa2n(1)-a2nsq)*ab1n(1)
      st6=(sc2n(1)-ab2n(n1))*ab1n(1)
      st9=(sb2n(1)-b2nsq(n1))*ab1n(1)
      ss3=(sa2n(1)-a2nsq)*b1nsq(1)
      ss6=(sc2n(1)-ab2n(n1))*b1nsq(1)
      ss9=(sb2n(1)-b2nsq(n1))*b1nsq(1)
      ttf(1)=ttf(1)+tt3*wssqpr+tt6*wstpr*2.0+tt9*wtsqpr
      stf(1)=stf(1)+st3*wssqpr+2.0*st6*wstpr+st9*wtsqpr
      ssf(1)=ssf(1)+ss3*wssqpr+2.0*ss6*wstpr+ss9*wtsqpr
      do 20 i=2,nloops
      tt1=sa1n(i)*a2nsq
      tt4=sc1n(i)*a2nsq
      tt7=sb1n(i)*a2nsq
      tt2=sa2n(i)*a1nsq
      tt5=sc2n(i)*a1nsq
      tt8=sb2n(i)*a1nsq
      st1=sa1n(i)*ab2n(i)
      st4=sc1n(i)*ab2n(i)
      st7=sb1n(i)*ab2n(i)
      st2=sa2n(i)*ab1n(i)
      st5=sc2n(i)*ab1n(i)
      st8=sb2n(i)*ab1n(i)
      ss1=sa1n(i)*b2nsq(i)
      ss4=sc1n(i)*b2nsq(i)
      ss7=sb1n(i)*b2nsq(i)
      ss2=sa2n(i)*b1nsq(i)
      ss5=sc2n(i)*b1nsq(i)
      ss8=sb2n(i)*b1nsq(i)
      if(i.eq.nloops) then
      tt3=0.
      tt6=0.
      tt9=0.
      st3=0.
      st6=0.
      st9=0.
      ss3=0.
      ss6=0.
      ss9=0.
      else
      tt3=(sa2n(i)-a2nsq)*a1nsq
      tt6=(sc2n(i)-ab2n(nloops+1))*a1nsq
      tt9=(sb2n(i)-b2nsq(nloops+1))*a1nsq
      st3=(sa2n(i)-a2nsq)*ab1n(i)
      st6=(sc2n(i)-ab2n(n1))*ab1n(i)
      st9=(sb2n(i)-b2nsq(n1))*ab1n(i)
      ss3=(sa2n(i)-a2nsq)*b1nsq(i)
      ss6=(sc2n(i)-ab2n(n1))*b1nsq(i)
      ss9=(sb2n(i)-b2nsq(n1))*b1nsq(i)
      endif
      ttf(i)=tt1*wssq(steps)+tt2*wssq0p+tt3*wssqpr
     & +2.*tt4*wst(steps)+2.*tt5*wst0p+2.0*tt6*wstpr
     & +tt7*wtsq(steps)+tt8*wtsq0p+tt9*wtsqpr
      stf(i)=st1*wssq(steps)+st2*wssq0p+st3*wssqpr
     & +2.0*st4*wst(steps)+2.0*st5*wst0p+2.0*st6*
     & wstpr+st7*wtsq(steps)+st8*wtsq0p+st9*wtsqpr
      ssf(i)=ss1*wssq(steps)+ss2*wssq0p+ss3*wssqpr
     & +2.0*ss4*wst(steps)+2.0*ss5*wst0p+2.0*ss6*
     & wstpr+ss7*wtsq(steps)+ss8*wtsq0p+ss9*wtsqpr
20    continue
30    i=nloops+1
      tt1=sa1n(i)*a2nsq
      tt2=0.
      tt3=0.
      tt4=sc1n(i)*a2nsq
      tt5=0.
      tt6=0.
      tt7=sb1n(i)*a2nsq
      tt8=0.
      tt9=0.
      st1=sa1n(n1)*ab2n(n1)
      st2=0.
      st3=0.
      st4=sc1n(n1)*ab2n(n1)
      st5=0.
      st6=0.
      st7=sb1n(n1)*ab2n(n1)
      st8=0.
      st9=0.
      ss1=sa1n(n1)*b2nsq(n1)
      ss2=0.
      ss3=0.
      ss4=sc1n(n1)*b2nsq(n1)
      ss5=0.
      ss6=0.
      ss7=sb1n(n1)*b2nsq(n1)
      ss8=0.
      ss9=0.
      ttf(i)=tt1*wssq(steps)+tt2*wssq0p+tt3*wssqpr
     & +2.*tt4*wst(steps)+2.*tt5*wst0p+2.*tt6*wstpr
     & +tt7*wtsq(steps)+tt8*wtsq0p+tt9*wtsqpr
      stf(i)=st1*wssq(steps)+st2*wssq0p+st3*wssqpr
     & +2.0*st4*wst(steps)+2.0*st5*wst0p+2.0*st6*
     & wstpr+st7*wtsq(steps)+st8*wtsq0p+st9*
     wtsqpr
      ssf(i)=ss1*wssq(steps)+ss2*wssq0p+ss3*wssqpr
     & +2.0*ss4*wst(steps)+2.0*ss5*wst0p+2.0*ss6*
     & wstpr+ss7*wtsq(steps)+ss8*wtsq0p+ss9*wtsqpr
99    return
      end
