        subroutine dle(error)
c control ray trace
        integer steps
        integer hcount,rcase,asize,count,step
        real lat,n0b
        logical nofloq,test1,test2,test3,error,undef
        logical ylong,yfluct,yray2
        logical reflct
      real zdl(1000),tdl(1000),ttdl(1000),s2bdl(1000),bfdl(1
     *000),pwtdl(1000),psqidl(1000),pdwt(1000),pdidl(1000),
     *qkv(1000),qkvsq(1000)
      common/rayst/zdl,tdl,ttdl,s2bdl,bfdl,pwtdl,psqidl,pdwt,pdidl
     *,qkv,qkvsq
      common/mpparm/sdepth,angle,h,hcount,rfinal,rdepth,freq,lat,nofloq
        common/parm/q0,q0inv,q0sq,range,n0b,wi,winv
        common/rparm/rmax,steps,hstore,hlas
        common/maxmin/rmax1,zmax,rzmax,zmin,rzmin,rtmax,ztmax,angmax
        common/stepb/dx,step
        common/ray/zlas,z,tlas,t,s2las,t2las,ttlas,tt,pslas,ps,pdlas,pd,
     *undef
        common/speed/c,dc,d2ur
        common/rtube/s2,t2
        common/const/pi
        common/option/yfluct,ylong,yray2
        common/surfac/reflct
         common/iounit/iuinp,iuout
c added common block from sfini to print out d11,..d23
        common/scalc/d11,d12,d13,d21,d22,d23
        data asize/1000/
c
c     initialize

       test1 = .false.
       test2 = .false.
       test3 = .false.
c
c         start ray and store quantities at step 1
c
          step=1
          z=sdepth
          t=tan(angle*pi/180.)
          dx=h
          range=0.
c call zstep.f at entry zinit to calculate ray quantities at step 1
          call zinit
          if (.not.undef) go to 301
          error=.true.
          return
301       continue
c
c         initialize applicable test for ray termination
c
c we don't use option 'nofloq=.true' anymore
          if (nofloq) go to 95
c t is the ray tangent at the step
c z is the ray depth at the step
          if (t.eq.0.) go to 75
          if (t.lt.0.) go to 70
          rcase=1
          test1=z.gt.sdepth
          go to 100
   70     rcase=2
          test1=z.lt.sdepth
          go to 100
   75     if (dc.ge.0.) go to 80
          rcase=3
          test1=t.gt.0.
          go to 100
   80     if (dc.eq.0.) go to 90
          rcase=4
          test1=t.lt.0.
          go to 100
c d2ur is the second derivative of the sound speed at the ray's depth z
   90     if (d2ur.lt.0.) go to 310
          rcase=0
          rmax=pi/sqrt(d2ur)
          rmax1=rmax
          test1=.true.
          go to 100
   95     rcase=0
          rmax=rmax1
          test1=.true.
  100     continue
c
c         initialize ray geometry maxima and minima
c
          zmin=sdepth
          zmax=sdepth
          ztmax=sdepth
          tmax=t
          rtmax=range
          rzmin=range
          rzmax=range
c
c     calculate rest of points on ray
c
          do 195 step=2,asize-1
c ray intergration step is dx;
c ray's quantities are  stored at steps dx*hcount
c
          do 190 count=1,hcount
c
          range=range+dx
c zstep.f calculates ray quantities at each step
          call zstep
          if (.not.undef) go to 300
          error=.true.
          return
300       continue
c
c     test if the last step has passed the maximum range
c
          go to (122,124,126,128,130), rcase+1
122       test2=abs(z).ge.rdepth.or.range.ge.rfinal
          test3=abs(z).ge.rdepth
c
c          write(iuout,*) z,rdepth,range,rfinal,rmax
c
          go to 140
  124     test2=z.le.sdepth
          go to 140
  126     test2=z.ge.sdepth
          go to 140
  128     test2=t.le.0.
          go to 140
  130     test2=t.ge.0.
  140     if (test1.and.test2) go to 200
          test1=.not.test2
c
c     reset maxima and minima
c
          if (z.ge.zmin) go to 181
          zmin=z
          rzmin=range
  181     if (z.le.zmax) go to 182
          zmax=z
          rzmax=range
  182     if (abs(t).le.tmax) go to 183
          tmax=t
          ztmax=z
          rtmax=range
  183     continue
  190     continue
          call zstore
c
  195     continue
c
c    if we reach this point it is an error because
c    the arrays storing the calculated functions are full
c
          go to 330
c
c    normal continuation
c    interpolate last point on ray
c
  200     continue
c          print *,'in dle,z=',z,'range=',range
          range=range-dx
c
c         find fraction of last step at which the ray
c         returns to its initial depth and angle
c
          go to (210,220,220,230,230), rcase+1
  210     if(abs(z).ge.rdepth) dx=h*(rdepth-abs(zlas))/
     &    (abs(z)-abs(zlas))
          if(range.ge.rmax) dx=amod(rmax,h)
          go to 250
  220     dx=h*(sdepth-zlas)/(z-zlas)
          go to 250
  230     dx=h*(0.    -tlas)/(t-tlas)
  250     continue
c
c         add this to final range reached to get double
c         loop length
c
          range=range+dx
          rmax=range
          rmax1=range
          if (test3) rfinal=range-0.01*h
          steps=step
c         store the function values at the last point on the ray
c
          z=zlas
          t=tlas
          s2=s2las
          t2=t2las
          tt=ttlas
          ps=pslas
          pd=pdlas
          if (dx.le.0.) go to 260
          call zindx
          call zstep
 260      continue
c
c     reset maxima and minima
c
          if (z.ge.zmin) go to 281
          zmin=z
          rzmin=range
  281     if (z.le.zmax) go to 282
          zmax=z
          rzmax=range
  282     if (abs(t).le.tmax) go to 283
          tmax=t
          ztmax=z
          rtmax=range
  283     continue
c
c for surface reflected rays change upper and lower turning points
c and find range of zmin=0.0
          reflct=zmin.lt.0.0
          if (zmin.lt.0.) then
          zmin=-zmin
          ix=0
c          print *,'rcase=',rcase
          if(rcase.eq.1) then
          rx=zmin*rzmin/(zmin+sdepth)
          else
          if(rcase.eq.2) then
          rx=zmin*(rmax1-rzmin)/(zmin+sdepth)
          ix=2.*rzmax/hstore
          else
c           print *,'rcase=',rcase
          endif
          endif
          rx=rzmin-rx
          irx=rx/hstore
          rx=hstore*irx
          if (zdl(irx).lt.0.) then
          dx0=-hstore
          ix=irx+ix
          iplus=-1
          else
          dx0=hstore
          ix=rzmin/hstore+1
          iplus=1
          endif
          i1=irx
          if(irx.eq.0) then
          i1=1
          rx=hstore
          endif
          i2=i1+iplus
c        print *,'irx,i1,i2',irx,i1,i2,'zdl(irx)',zdl(irx) 
c       print *,'zdli1',zdl(i1),'zdl(i2)',zdl(i2),'dx0',dx0,'ix',ix
          do 55 i=1,ix
          testx=zdl(i1)*zdl(i2)
c         print *,'i1,i2,rx=',i1,i2,rx
          if(testx.lt.0.) go to 57
          i1=i2
          i2=i2+iplus
          rx=rx+dx0
c        print *,'i,i1,i2,rx',i,i1,i2,rx,' zdl(i1)',zdl(i1)
c        print *,' zdl(i2)',zdl(i2)
55         continue
57         rx=rx-dx0
          dx0=dx0*abs(zdl(i1))/(abs(zdl(i1))+abs(zdl(i2)))
c          print *,'rx=',rx,' dx0=',dx0 
          rx=rx+dx0
c next few lines are commented out-we decided, that,even if abs(zmin)>zmax
c the difference  between zmax ans abs(zmin) is not large(a few meteres).
c and we don't have to change zmax
c          print *,'rx last = rzmin',rx
           if(zmin.gt.zmax) then
          if(rzmin.lt.rzmax) then
c       print *,'zmax',zmax,'zmin',zmin,'rzmax,rzmin',rzmax,rzmin
          zmax=zmin
           rzmax=rzmin 
        endif
        endif
          zmin=0.
          rzmin=rx
          endif
          if (ztmax.lt.0.) then
          ztmax=-ztmax
          tmax=-tmax
          endif
c
          call zstore
c
          angmax=atan(tmax)*180./pi
c
c     construct fundamental floquet solutions
c
          call sfini(nofloq,fcase1,step)
c         print *,'in dle,sfini',rfinal,step,d11,d12,d13,d21,d22,d23
c
          error=.false.
          return
c
c     error messages
c
  310     error=.true.
         if(ylong) call dlaerr(2,range,z,t)
          return
  330     error=.true.
          if(ylong)call dlaerr(4,range,z,t)
          return
      end
