      subroutine freqsc
c  calculate tau0 , tau1 (using wtau1.f), and wnuin, using Floquet solution,
c as described in S.M.Flatte and R.B.Stoughton 'Predictions of internal-
c wave effects on ocean acoustics coherence...', 1988 (see 'User's Guide
c to CAFI' for reference).
        logical yfluct,ylong,yray2
        integer steps,hcount
        double precision wron,s2rw
	real intl,logphi,lambda,lamphi,lmphsq,lphovc,n0b,lat
        real wtsq(1000),wst(1000),wssq(1000)
        real zdl(1000),tdl(1000),ttdl(1000),s2bdl(1000),bfdl(1000),
     & pwtdl(1000),psqidl(1000),pdwt(1000),pdidl(1000),qkv(1000),
     & qkvsq(1000)
        real dlama1(1000),dlama2(1000),dlama3(1000),dkvsq(1000)
     & ,dtt(1000),dnupsq(1000),dkhl(1000)
	common/iounit/iuinp,iuout
	common/lphi/phisq,phi,logphi,lambda,lamphi,lmphsq
	common/tau/tau1,tau0sq,tau0
        common/wnu/wnuin
        common/sr/s1r,s2r,wron,s2rw
      common/rayst/zdl,tdl,ttdl,s2bdl,bfdl,pwtdl,psqidl,pdwt,pdidl,
     & qkv,qkvsq
      common/rayst2/dlama1,dlama2,dlama3,dkvsq,dtt,dnupsq,dkhl
      common/rparm/rmax,steps,hstore,hlas
      common/loops/nloops,itmin,rfrac
      common/mpparm/sdepth,angle,h,hcount,rfinal,rdepth,freq,lat,nofloq
      common/parm/q0,q0inv,q0sq,range,n0b,wi,winv
      common/wints/wtsq,wst,wssq,wtsq0p,wst0p,wssq0p,loc
      common/sumg/sumg1,sumg2,sumg3,sumg4,sumg5,sumg6,sumg7
     &,sumg8,sumg9,sumg10,sumg11
      common/sumgn/g1n,g2n,sumg1n,sumg2n,g3n,g4n,sumg4n,g5n
     &,sumg5n,g6n,sumg6n,g7n,g8n,sumg8n,g9n,sumg9n,g10n,g11n
      common/fcoef/fttnpr,fstnpr,fssnpr,fttn,fstn,fssn
c
      common/option/yfluct,ylong,yray2
c find sound speed at the axis (C0)
        call ssc0(c0)
	lphovc = logphi/c0
c I think ntauint was a diagnostic file, not otherwise necessary.
c RKA 20120918
c     open(11,file='ntauint')
      rewind 11
      tau0sq=0.
      wnuin=0.
      ssint=0.
      ttint=0.
      stint=0.
      s1rsq=s1r*s1r
c we calculate integrals SS(u),ST(u),TT(u) as in eq.(A26) in the Appendix
c of the article; sumg* been the sum of the products of coefficients a1n-2bn
c as in eqs.(A4,A13-A15) of the Appendix of the article,calculated in gu.f 
c integrals wst(i),wtsq(i),wssq(i), calculated in ntgraltau.f
c then we use (calculted in ftt.f fst.f fss.f ) fttn,ftsn,fssn 
c for tau0sq value (eq.22)
c and call wtau1.f to calculate tau1 (eq.21) using the same method and same
c partial sums and the integrals and the integral sums
      do 20 i=1,loc
      j=i
      gtt=2.0*sumg1n*wst(i)+sumg2n*wtsq(i)+sumg3*wssq(steps)+
     & 2.0*(wst(steps)-wst(j))*sumg4+sumg5*(wtsq(steps)-wtsq(j))
     & +g3n*wssq0p+2.0*g4n*(wst0p-wst(j))+g5n*(wtsq0p-wtsq(j))
      gst=sumg4n*wssq(i)+sumg6n*wtsq(i)+sumg1*(wssq(steps)-wssq(j))
     & +2.0*sumg7*wst(steps)+sumg8*(wtsq(steps)-wtsq(j))
     & +g1n*(wssq0p-wssq(j))+2.0*g7n*wst0p+g8n*(wtsq0p-wtsq(j))
      gss=sumg5n*wssq(i)+2.0*sumg9n*wst(i)+sumg2*(wssq(steps)-wssq(j))
     & +2.0*sumg10*(wst(steps)-wst(j))+sumg11*wtsq(steps)
     & +g2n*(wssq0p-wssq(j))+2.0*g10n*(wst0p-wst(j))+g11n*wtsq0p
c tdl(i) and s2bdl(i) are two linerly independent solutions of the ray-tube
c equation, as in (A3) of the article, s(u) and t(u).
      ssi=(s2bdl(i)**2)*(fttn+gtt)
      sti=tdl(i)*s2bdl(i)*(fstn+gst)
      tti=(tdl(i)**2)*(fssn+gss)
      sall=ssi+2.*sti+tti
      taui=dkvsq(i)*sall
      wnui=dnupsq(i)*sall
      if(i.eq.loc) then
      wnufr1=wnui
      taufr1=taui
      go to 20
      endif
      wnuin=wnuin+wnui
      tau0sq=tau0sq+taui
20    continue
      if(nloops.eq.0) go to 50
      if(loc.gt.steps-2) go to 48
      do 40 i=loc,steps-2
c      j=i-1
      j=i
      gtt=2.0*sumg1*wst(i)+sumg2*wtsq(i)+sumg3*wssq(steps)+
     & 2.0*(wst(steps)-wst(j))*sumg4+sumg5*(wtsq(steps)-wtsq(j))
      gst=sumg4*wssq(i)+sumg6*wtsq(i)+sumg1*(wssq(steps)-wssq(j))
     & +2.0*sumg7*wst(steps)+sumg8*(wtsq(steps)-wtsq(j))
      gss=sumg5*wssq(i)+2.0*sumg9*wst(i)+sumg2*(wssq(steps)-wssq(j))
     & +2.0*sumg10*(wst(steps)-wst(j))+sumg11*wtsq(steps)
      ssi=(s2bdl(i)**2)*(fttnpr+gtt)
      sti=tdl(i)*s2bdl(i)*(fstnpr+gst)
      tti=(tdl(i)**2)*(fssnpr+gss)
c total integral sum
      sall=ssi+2.*sti+tti
      taui=dkvsq(i)*sall
      wnui=dnupsq(i)*sall
      if(i.eq.loc) then
      taufr2=taui
      wnufr2=wnui
      go to 40
      endif
      tau0sq=tau0sq+taui
      wnuin=wnuin+wnui
c      x=hstore*(i-1)/1000.0
c      owt=taui*s1r*s1r

c I commented this out NOTE the open statement also commented
c out. Search on RKA. 
c      write(11,*) x,owt,dkvsq(i),taui/dkvsq(i)

40    continue
      taui=0.0
       wnui=0.0
48    if (loc.gt.steps-1) go to 50
      i=steps-1
      gtt=2.0*sumg1*wst(i)+sumg2*wtsq(i)+sumg3*wssq(steps)+
     & 2.0*(wst(steps)-wst(j))*sumg4+sumg5*(wtsq(steps)-wtsq(j))
      gst=sumg4*wssq(i)+sumg6*wtsq(i)+sumg1*(wssq(steps)-wssq(j))
     & +2.0*sumg7*wst(steps)+sumg8*(wtsq(steps)-wtsq(j))
      gss=sumg5*wssq(i)+2.0*sumg9*wst(i)+sumg2*(wssq(steps)-wssq(j))
     & +2.0*sumg10*(wst(steps)-wst(j))+sumg11*wtsq(steps)
      ssin=(s2bdl(i)**2)*(fttnpr+gtt)
      stin=tdl(i)*s2bdl(i)*(fstnpr+gst)
      ttin=(tdl(i)**2)*(fssnpr+gss)
      sall=ssin+2.*stin+ttin
      taui=dkvsq(i)*sall
      wnui=dnupsq(i)*sall
c      if(wnui.lt.0.) then
c      wnui=0.
c      endif
c      if(taui.lt.0.) then
c      taui=0.
c      endif
50    continue
      hfrac=rfrac-hstore*(loc-1)
      hfrac2=hstore-hfrac
      tau0sq=tau0sq*hstore+taui*hlas+taufr1*hfrac+taufr2*hfrac2	
      wnuin=(wnuin*hstore+wnui*hlas+wnufr1*hfrac+wnufr2*hfrac2)*s1r*s1r
c      close (11)
      call wtau1
c re-arranged tau1=(ln(phi)/C)*s1r*Integral...
        s1rlp=lphovc*s1r/2.0
        tau1=tau1*s1rlp
        tau0sq=tau0sq*s1rlp*s1rlp
        if(tau0sq.lt.0.0) then
        tau0=0.0
        else
	tau0=sqrt(tau0sq)
        endif
        if(ylong) then
	write(iuout,110)
c writes out tau0 and tau1 values in milliseconds
	write(iuout,111) 1000.*tau1, 1000.*tau0,1./tau0
        endif
 110	format(/'FREQUENCY SCALES (Coherent Bandwidth)'/)
 111	format(
     *'derivative of Q phase at zero frequency     = tau1       = ',
     *g12.5,  'millisec',/,
     *'second derivative of Q (square root)        = tau0       = ',
     *g12.5,  'millisec',/,
     *'(controls pulse spread)',/,
     *'coherent bandwidth                          = 1/tau0     = ',
     *g12.5,  'Hz',/)
 121     format(4e12.5)
	return 
	end
