      subroutine ftt
c to calculate integral sum *TT* in eq.(A22-A23) of S.M.Flatte's and
c R.B.Stoughton 'Predictions of internal-wave effects on ocean acoustic
c coherence,...',1988. Read 'User's Guide to CAFI' for more information
c steps=number of stored steps for one double-loop
      integer steps
c a1n,b1n,etc are defined by eq.(A13-A15); a1n*-ab*, sa2n(), sb2n() etc. are
c various combinations of these coefficients used in the equations for
c fluctuation parameters
      real a1nsq,a2nsq,b1nsq(900),b2nsq(900),
     & ab1n(900),ab2n(900),sa1n(900),sa2n(900),sb1n(900),
     & sb2n(900),sc1n(900),sc2n(900)
c wtsq(),wst(),wssq() are integrals of w(u)*t(u)^2,etc. in eq.(A23)
      real wtsq(1000),wst(1000),wssq(1000)
      common/loops/nloops,itmin,rfrac
      common/rparm/rmax,steps,hstore,hlas
      common/ab/a1nsq,a2nsq,b1nsq,b2nsq,ab1n,ab2n,sa1n,sa2n,
     & sb1n,sb2n,sc1n,sc2n
      common/fcoef/fttnpr,fstnpr,fssnpr,fttn,fstn,fssn
      common/wints/wtsq,wst,wssq,wtsq0p,wst0p,wssq0p,loc
      sumtt1=0.0
      sumtt2=0.0
      sumtt3=0.0
      sumtt4=0.0
      sumtt5=0.0
      sumtt6=0.0
      sumtt7=0.0
      sumtt8=0.0
      sumtt9=0.0
      fttnpr=0.
      fttn=0.
      if(nloops.eq.0) go to 99
      sumtt2=sa2n(1)*a1nsq
      sumtt5=sc2n(1)*a1nsq
      sumtt8=sb2n(1)*a1nsq
      if(nloops.eq.1) go to 30
      sumtt3=sumtt3+(sa2n(1)-a2nsq)*a1nsq
      sumtt6=sumtt6+(sc2n(1)-ab2n(nloops+1))*a1nsq
      sumtt9=sumtt9+(sb2n(1)-b2nsq(nloops+1))*a1nsq
      do 20 i=2,nloops
      sumtt1=sumtt1+sa1n(i)*a2nsq
      sumtt4=sumtt4+sc1n(i)*a2nsq
      sumtt7=sumtt7+sb1n(i)*a2nsq
      sumtt2=sumtt2+sa2n(i)*a1nsq
      sumtt5=sumtt5+sc2n(i)*a1nsq
      sumtt8=sumtt8+sb2n(i)*a1nsq
      if(i.eq.nloops) go to 30
      sumtt3=sumtt3+(sa2n(i)-a2nsq)*a1nsq
      sumtt6=sumtt6+(sc2n(i)-ab2n(nloops+1))*a1nsq
      sumtt9=sumtt9+(sb2n(i)-b2nsq(nloops+1))*a1nsq
20    continue
30    i=nloops+1
      stt1n=sumtt1+sa1n(i)*a2nsq
      stt2n=sumtt2
      stt3n=sumtt3
      stt4n=sumtt4+sc1n(i)*a2nsq
      stt5n=sumtt5
      stt6n=sumtt6
      stt7n=sumtt7+sb1n(i)*a2nsq
      stt8n=sumtt8
      stt9n=sumtt9
      fttnpr=sumtt1*wssq(steps)+sumtt2*wssq0p+sumtt3*(wssq(steps)-
     & wssq0p)+2.*sumtt4*wst(steps)+2.*sumtt5*wst0p+sumtt6*(wst(steps)
     &-wst0p)*2.+sumtt7*wtsq(steps)+sumtt8*wtsq0p+sumtt9*(wtsq(steps)-
     & wtsq0p)
      fttn=stt1n*wssq(steps)+stt2n*wssq0p+stt3n*(wssq(steps)-
     & wssq0p)+2.*stt4n*wst(steps)+2.*stt5n*wst0p+stt6n*(wst(steps)
     &-wst0p)*2.+stt7n*wtsq(steps)+stt8n*wtsq0p+stt9n*(wtsq(steps)-
     & wtsq0p)
99      return
      end
