      subroutine gu
c calculates sums of the products of a1n,a2n,b1n,b2n coefficients needed
c in calculations of various fluctuation parameters (such as tau0,tau1,nu,etc)
c as discribed in S.M.Flatte and R.B.Stoughton 'Predictions of internal-wave
c effects on ocean acoustic coherence...'1988 (see 'User's Guide to CAFI'
c for reference).
c uses a1n*,a2n*,b1n*,b2n*,ab* calculated in taucoef.f
c output is sumg* and g* used in freqsc.f, wtau1.f,etc
      real a1nsq,a2nsq,b1nsq(900),b2nsq(900),
     & ab1n(900),ab2n(900),sa1n(900),sa2n(900),sb1n(900),
     & sb2n(900),sc1n(900),sc2n(900)
      real g1(900),g2(900),g3,g4(900),g5(900),g6(900),g7(900),
     & g8(900),g9(900),g10(900),g11(900)
      common/loops/nloops,itmin,rfrac
      common/ab/a1nsq,a2nsq,b1nsq,b2nsq,ab1n,ab2n,sa1n,sa2n,
     & sb1n,sb2n,sc1n,sc2n
      common/sumg/sumg1,sumg2,sumg3,sumg4,sumg5,sumg6,sumg7
     &,sumg8,sumg9,sumg10,sumg11
      common/sumgn/g1n,g2n,sumg1n,sumg2n,g3n,g4n,sumg4n,g5n
     &,sumg5n,g6n,sumg6n,g7n,g8n,sumg8n,g9n,sumg9n,g10n,g11n
      common/gcoef/g1,g2,g3,g4,g5,g6,g7,g8,g9,g10,g11
      sumg1=0.0
      sumg2=0.0
      sumg3=0.0
      sumg4=0.0
      sumg5=0.0
      sumg6=0.0
      sumg7=0.0
      sumg8=0.0
      sumg9=0.0
      sumg10=0.0
      sumg11=0.0
      sumg1n=0.0
      sumg2n=0.0
      sumg5n=0.0
      sumg6n=0.0
      sumg8n=0.0
      sumg9n=0.0
      g3=a1nsq*a2nsq
      if(nloops.eq.0) go to 30
      do 20 i=1,nloops
      g1(i)=a2nsq*ab1n(i)
      sumg1=sumg1+g1(i)
      g2(i)=a2nsq*b1nsq(i)
      sumg2=sumg2+g2(i)
      sumg3=sumg3+g3
      g4(i)=a1nsq*ab2n(i)
      sumg4=sumg4+g4(i)
      g5(i)=a1nsq*b2nsq(i)
      sumg5=sumg5+g5(i)
      g6(i)=ab2n(i)*b1nsq(i)
      sumg6=sumg6+g6(i)
      g7(i)=ab1n(i)*ab2n(i)
      sumg7=sumg7+g7(i)
      g8(i)=ab1n(i)*b2nsq(i)
      sumg8=sumg8+g8(i)
      g9(i)=ab1n(i)*b2nsq(i)
      sumg9=sumg9+g9(i)
      g10(i)=ab2n(i)*b1nsq(i)
      sumg10=sumg10+g10(i)
      g11(i)=b1nsq(i)*b2nsq(i)
      sumg11=sumg11+g11(i)
20    continue
c if U<P add one more member to sums
30    continue
      i=nloops+1
      g1n=a2nsq*ab1n(i)
      g1(i)=g1n
      sumg1n=sumg1+g1n
      g2n=a2nsq*b1nsq(i)
      g2(i)=g2n
      sumg2n=sumg2+g2n
      g3n=a1nsq*a2nsq
      g4n=a1nsq*ab2n(i)
      g4(i)=g4n
      sumg4n=sumg4+g4n
      g5n=a1nsq*b2nsq(i)
      g5(i)=g5n
      sumg5n=sumg5+g5n
      g6n=ab2n(i)*b1nsq(i)
      g6(i)=g6n
      sumg6n=sumg6+g6n
      g7n=ab1n(i)*ab2n(i)
      g7(i)=g7n
      g8n=ab1n(i)*b2nsq(i)
      g8(i)=g8n
      sumg8n=sumg8+g8n
      g9n=ab1n(i)*b2nsq(i)
      g9(i)=g9n
      sumg9n=sumg9+g9n
      g10n=ab2n(i)*b1nsq(i)
      g10(i)=g10n
      g11n=b1nsq(i)*b2nsq(i)
      g11(i)=g11n
      return
      end
