      subroutine smthn(n1,n2,x,y,dy,s,a,b,c,d)
c
c    smoothing by spline functions, c. h. reinsch
c    numerische mathematik, 1967 (10) 177-183
c
c     smthn requires n2>n1 and x strictly increasing.
c     the maximum array size is set in common to 1000.
c
c     warning? smthn is arranged to let the array arguments of some
c     arrays be set equal to zero.  the memory locations preceding
c     the arrays are therefore unusable and are arranged to be protected.
c     this might cause a problem on some machines.
c
      dimension a(1000),b(1000),c(1000),d(1000),x(1000),y(1000)
      real r(0:1001),r2(0:1001),u(0:1001)
      real dy(1000)
      common/csmth/dum(1),r,r1(1002),r2,t(1002),t1(1002),
     1 v(1002)
      nmax=1000
      if(n2.gt.nmax) stop
      m1=n1-1
      m2=n2+1
      r(m1)=0.
      r(n1)=0.
      u(m1)=0.
      u(n1)=0.
      u(n2)=0.
      u(m2)=0.
      r1(n2)=0.
      r2(n2)=0.
      r2(m2)=0.
      p=0.
      m1=n1+1
      m2=n2-1
      h=x(m1)-x(n1)
      f=(y(m1)-y(n1))/h
      do 10 i=m1,m2
      g=h
      h=x(i+1)-x(i)
      e=f
      f=(y(i+1)-y(i))/h
      a(i)=f-e
      t(i)=2.*(g+h)/3.
      t1(i)=h/3.
      r2(i)=dy(i-1)/g
      r(i)=dy(i+1)/h
      r1(i)=-dy(i)/g-dy(i)/h
   10 continue
      do 20 i=m1,m2
      b(i)=r(i)**2+r1(i)**2+r2(i)**2
      c(i)=r(i)*r1(i+1)+r1(i)*r2(i+1)
      d(i)=r(i)*r2(i+2)
   20 continue
      f2=-s
   30 do 40 i=m1,m2
      r1(i-1)=f*r(i-1)
      r2(i-2)=g*r(i-2)
      r(i)=1./(p*b(i)+t(i)-f*r1(i-1)-g*r2(i-2))
      u(i)=a(i)-r1(i-1)*u(i-1)-r2(i-2)*u(i-2)
      f=p*c(i)+t1(i)-h*r1(i-1)
      g=h
      h=d(i)*p
   40 continue
      do 50 j=m1,m2
      i=m2+m1-j
      u(i)=r(i)*u(i)-r1(i)*u(i+1)-r2(i)*u(i+2)
   50 continue
      e=0.
      h=0.
      do 60 i=n1,m2
      g=h
      h=(u(i+1)-u(i))/(x(i+1)-x(i))
      v(i)=(h-g)*(dy(i)**2)
      e=e+v(i)*(h-g)
   60 continue
      g=-h*(dy(n2)**2)
      v(n2)=g
      e=e-g*h
      g=f2
      f2=e*(p**2)
      if(f2.ge.s.or.f2.le.g) go to 80
      f=0.
      h=(v(m1)-v(n1))/(x(m1)-x(n1))
      do 70 i=m1,m2
      g=h
      h=(v(i+1)-v(i))/(x(i+1)-x(i))
      g=h-g-r1(i-1)*r(i-1)-r2(i-2)*r(i-2)
      f=f+g*r(i)*g
      r(i)=g
   70 continue
      h=e-p*f
      if(h.le.0.) go to 80
      p=p+(s-f2)/((sqrt(s/e)+p)*h)
      go to 30
   80 do 90 i=n1,n2
      a(i)=y(i)-p*v(i)
      c(i)=u(i)
   90 continue
      do 100 i=n1,m2
      h=x(i+1)-x(i)
      d(i)=(c(i+1)-c(i))/(3.*h)
      b(i)=(a(i+1)-a(i))/h-(h*d(i)+c(i))*h
  100 continue
      b(n2)=0.
      d(n2)=0.
      return
      end
