      subroutine sspeed(z,c,dc,d2ur,undef)
c     computes sound speed and its derivatives by cubic spline
c     interpolation of smoothed experimental data.
c     the cubic spline coefficients are contained in array scoef.
c     experimental data are input from the directory at runtime.
          common/names/sfile,bfile
          character*30 sfile,bfile
          real zdata(1000),cdata(1000),sdata(1000),dya(1000)
          real c1(1000),c2(1000),c3(1000)
          logical undef
          character*10 legnd(6,3),ssname
          character*60 form
          common/ssname/ssname
          common/iounit/iuinp,iuout
          common/ssparm/ss,dy
          common/zparm/zmin,zmax
           common/zcdata/iz,zdata,sdata,dya,c1,c2,c3,c0,ncdata
           save
          data lfn / 9 /
          data ss,dy/-1.,-1./
c
c z is the current depth, zdata(iz) is the depth from the ss profile
c closest to the depth at previouse call to sspeed
          if (z-zdata(iz)) 20,35,10
   10     if (iz.eq.ncdata) go to 50
          if (z.le.zdata(iz+1)) go to 35
          iz=iz+1
          go to 10
   20     iz=iz-1
          if (iz.eq.0) go to 45
          if (z.ge.zdata(iz)) go to 35
          go to 20
   35     h=z-zdata(iz)
c
c     calculate sound speed and derivs for ray
c    using c1(iz), c2(iz), c3(iz) smoothing coefficients from smthn.f
c
          c=sdata(iz)+h*(c1(iz)+h*(c2(iz)+h*c3(iz)))
          dc=c1(iz)+h*(2.*c2(iz)+3.*h*c3(iz))
          d2ur=(2.*c2(iz)+6.*h*c3(iz))/c
          undef=.false.
          return
   45     iz=ncdata/2
   50     undef=.true.
          return
      entry ssc0(z)
          z=c0
          return
      entry ssinit
c     finds coefficients for a cubic spline interpolation of
c     experimental data.
c
c     read data in
c
          open(lfn,file=sfile)
c
          rewind lfn
c read 1st 3 lines of the ss profile file-text with notes about the profile.
          read(lfn,1000) legnd
 1000     format(6a10/6a10/6a10)
c this is the profile's name-to be printed in 'long output'
          read(lfn,1010) ssname
 1010     format(a10)
c the main profile and smoothing parameters
          read(lfn,*) stemp
          read(lfn,*) dytemp
          read(lfn,*) ncdata
          read(lfn,*) zmin
          read(lfn,*) zmax
          read(lfn,*) zconv
          read(lfn,*) cconv
c format the profile data written in  
          read(lfn,1030) form
 1030     format(a60)
c assign smoothing parameters if not set in parameter file
c the larger dy is-the more smoothing  is done
c dy is the  max deviation from
c ss profile allowed at a depth. we use the same number for all depths
c usually you can start with a small (dy=0.1 or even dy=0.0) 
c -the profile might be smooth enough. 
c Increase dy gradually, if more smoothing  is desired
          if (ss.lt.0.) ss=stemp
          if (dy.lt.0.) dy=dytemp
          c0=1.e10
c make simmetric around the surface profile with min(depth)=-max(depth)
c and C(min.depth)=C(max.depth); ss(-z)=ss(z)
              zmin=-zmax
              ncdat0=ncdata
              ncdata=ncdata*2-1
c read data at surface or closest to surface depth
              read(lfn,form) depth,speed
              c0=amin1(c0,speed)
              zdata(ncdat0)=zconv*depth
              cdata(ncdat0)=cconv*speed
              itop=ncdat0+1
              if(depth.eq.0.0) go to 444
              ncdata=ncdata+1
              zdata(ncdat0)=-zconv*depth
              cdata(ncdat0+1)=cdata(ncdat0)
              zdata(ncdat0+1)=-zdata(ncdat0)
              ncdat0=ncdat0+1
              itop=itop+1
c read in the rest of ss profile  
  444       do 500 i=itop,ncdata
              j=ncdata-i+1
              read (lfn,form) depth,speed
              c0=amin1(c0,speed)
              zdata(i)=zconv*depth
              cdata(i)=cconv*speed
c and construct the "surface-reflected" part of the profile
              zdata(j)=-zdata(i)
  500         cdata(j)=cconv*speed
          c0=cconv*c0
c
c          close(lfn,status='keep')
c
c     assign weights and smoothing parameter
c          
c assign the same smoothing parameter to all depth values.
c (you can easily change it, if you want dya(i) to be different
c for different i-just remember, that we use negative depth to make
c faster calculations for surface-reflected rays, so 
c maximum depth is zdata(ncdata)=-zdata(1)
c and the surface location is i=ncdata/2.0)
          do 505 i=1,ncdata
  505         dya(i)=dy
c     calculate smoothed data points
          call smthn(1,ncdata,zdata,cdata,dya,ss,sdata,c1,c2,c3)
          iz=ncdat0
          zdata(1)=zmin
          zdata(ncdata)=zmax
          return
      entry sslist
          write(iuout,9000) ssname
 9000     format(
     *    a7,' sound speed profile parameters'/)
      write(iuout,9100) ss,dy
 9100 format(
     *'ss        smoothing parameter           ',g12.5,'           '/
     *'dy        std. dev. of data             ',g12.5,' m/sec     '/)
          return
          end
