      subroutine tcoef
c to calculate coefficients a1n, a2n, b1n, b2n  and their products and
c sumd, as in  eq. (A3), (A4), (A13), (A20)
c needed in SS, ST, TT integrals (A23)-(A26) (calculated in alphaf.f) 
c from S.M.Flatte' and R.B.Stoughton "Predictions of internal-wave effects..."
c (see 'User`s guide for CAFI' for the reference).
      double precision wron,s2rw,s21r
      real a1nsq,a2nsq,b1nsq(900),b2nsq(900),
     & ab1n(900),ab2n(900),sa1n(900),sa2n(900),sb1n(900),
     & sb2n(900),sc1n(900),sc2n(900)
      real b12(900),a1b2(900),a2b1(900)
      common/ab12/a12,b12,a1b2,a2b1
      common/loops/nloops,itmin,rfrac
      common/scalc/d11,d12,d13,d21,d22,d23
      common/sr/s1r,s2r,wron,s2rw
      common/ab/a1nsq,a2nsq,b1nsq,b2nsq,ab1n,ab2n,sa1n,sa2n,
     & sb1n,sb2n,sc1n,sc2n
      common/ta1/sa12,sb12,sab12,sa12n,sb12n,sab12n
c d11,d12,d13,d21,d22,d23 are calculated in sfini.f
      s21r=s2rw
      a1n=d13*wron
      a2n=d23-s21r*d13
      a1nsq=a1n*a1n
      a2nsq=a2n*a2n
      a12=a1n*a2n
c calculate constant for the ray parts of the coefficients 
      b1c=d11*wron
      b2c=d21-s21r*d11
      b1v=d12*wron
      b2v=d22-s21r*d12
      b2nsq(1)=b2c*b2c
      ab1n(1)=a1n*b1c
      ab2n(1)=a2n*b2c
      b1nsq(1)=b1c*b1c
      b2nsq(1)=b2c*b2c
      sa1n(1)=0.0
      sa2n(1)=0.0
      sb1n(1)=0.0
      sb2n(1)=0.0
      sc1n(1)=0.0
      sc2n(1)=0.0
      sa12=0.0
      sb12=0.0
      sab12=0.0
      sa12n=a12
      b12(1)=b1c*b2c
      sb12n=b12(1)
      a1b2(1)=a1n*b2c
      a2b1(1)=a2n*b1c
      sab12n=a1b2(1)+a2b1(1)
c      sab12n=sa12n-sb12n
      if(nloops.eq.0) go to 99
      sa2n(1)=a2nsq
      sb2n(1)=b2nsq(1)
      sc2n(1)=ab2n(1)
      sa12=a12
      sb12=b1c*b2c
      sab12=sab12n
c      print *, 'in taucoef'
c      print *,'i,ab1n(i),ab2n(i),b1nsq(i),b2nsq(i)'
c      print *,'i,b12(i),a1b2(i),a2b1(i)'
c      print *,'i,sa1n(i),sb1n(i),sc1n(i),sa12n,sb12n,sab12n'
      do 20 i=2,nloops+1
      b1=b1c+(i-1)*b1v
      b1nsq(i)=b1*b1
      ab1n(i)=b1*a1n
      b2=b2c+(i-1)*b2v
      b2nsq(i)=b2*b2
      ab2n(i)=b2*a2n
      sa1n(i)=sa1n(i-1)+a1nsq
      sb1n(i)=sb1n(i-1)+b1nsq(i-1)
      sc1n(i)=sc1n(i-1)+ab1n(i-1)
      sa2n(i)=sa2n(i-1)+a2nsq
      sb2n(i)=sb2n(i-1)+b2nsq(i)
      sc2n(i)=sc2n(i-1)+ab2n(i)
      b12(i)=b1*b2
      a1b2(i)=a1n*b2
      a2b1(i)=a2n*b1
      sa12n=sa12n+a12
      sb12n=sb12n+b12(i)
      sab12n=sab12n+a1b2(i)+a2b1(i)
c      sab12n=sab12n+a12-b12
      if(i.eq.nloops+1) go to 20
      sa12=sa12n
      sb12=sb12n
      sab12=sab12n
c      print *,i,ab1n(i),ab2n(i),b1nsq(i),b2nsq(i)
c      print *,i,b12(i),a1b2(i),a2b1(i)
c      print *,i,sa1n(i),sb1n(i),sc1n(i),sa12n,sb12n,sab12n
20    continue
      sa2nn=sa2n(nloops+1)
      sb2nn=sb2n(nloops+1)
      sc2nn=sc2n(nloops+1)
c      print *,'sa2nn,sb2nn,sc2nn'
c      print *,sa2nn,sb2nn,sc2nn
c      print *,'i,sa2n(i),sb2n(i),sc2n(i)'
      sa2n(1)=sa2nn-a2nsq
      sb2n(1)=sb2nn-b2nsq(1)
      sc2n(1)=sc2nn-ab2n(1)
c      print *,'1',sa2n(1),sb2n(1),sc2n(1)
      sa2n(2)=0.
      sb2n(2)=0.
      sc2n(2)=0.
      if(nloops.eq.1) go to 99
      do 40 i=2,nloops
      sa2n(i)=sa2n(i-1)-a2nsq
      sb2n(i)=sb2n(i-1)-b2nsq(i)
      sc2n(i)=sc2n(i-1)-ab2n(i)
40    continue
      i=nloops
      sa2n(i+1)=0.
      sb2n(i+1)=0.
      sc2n(i+1)=0.
99    continue
      i=nloops+2
      b1=b1c+(i-1)*b1v
      b1nsq(i)=b1*b1
      ab1n(i)=b1*a1n
      sa1n(i)=sa1n(i-1)+a1nsq
      sb1n(i)=sb1n(i-1)+b1nsq(i-1)
      sc1n(i)=sc1n(i-1)+ab1n(i-1)
      return
      end
