      subroutine bvfreq(z,n,undef)
c
c     computes buoyancy frequency at a given depth by cubic spline
c     interpolation of smoothed experimental data.
c     the cubic spline coefficients are contained in array scoef.
c     they are input from a file in the directory at runtime.
c
      real zdata(1000),ndata(1000),sdata(1000),dyya(1000),c1(1000),
     *c2(1000),c3(1000),n,nconv
          character*10 bfname,legnd(6,3),form(6)
          logical undef
          common/iounit/iuinp,iuout
          common/bfname/bfname
          common/names/sfile,bfile
          character*30 sfile,bfile
          common/bfparm/sss,dyy
          data iz/1/
          common/bfdata/iz,zdata,sdata,dyya,c1,c2,c3,nndata
          data zmin,zmax,sss,dyy/1000.,0.,-1.,-1./
          data lfn / 9 /
c
          if (z-zdata(iz)) 20,35,10
   10     if (iz.eq.nndata) go to 50
          if (z.le.zdata(iz+1)) go to 35
          iz=iz+1
          go to 10
   20     iz=iz-1
          if (iz.eq.0) go to 45
          if (z.ge.zdata(iz)) go to 35
          go to 20
   35     h=z-zdata(iz)
          n=sdata(iz)+h*(c1(iz)+h*(c2(iz)+h*c3(iz)))
          undef=.false.
          return
   45     iz=nndata/2
   50     undef=.true.
          return
c
      entry bfinit
c
c     finds coefficients for a cubic spline interpolation of
c     experimental data.
c
c     read data in 
c
          open(lfn,file=bfile)
          rewind lfn
          read (lfn,1000) legnd,bfname
          read (lfn,*) stemp
          read (lfn,*) dytemp
          read (lfn,*) nndata
          read (lfn,*) z1
          read (lfn,*) z2
          read (lfn,*) zconv
          read (lfn,*) nconv
          read (lfn,1110) form
c          read (lfn,1000) legnd,bfname,stemp,dytemp,nndata,
c     *        z1,z2,zconv,nconv,form
c 1000     format(3(6a10/),a10/f15.5/f15.5/i5/4(f15.5/),6a10)
 1000     format(3(6a10/),a10)
 1110     format(6a10)
          if (sss.lt.0.) sss=stemp
          if (dyy.lt.0.) dyy=dytemp
          if (zmin.lt.zmax) go to 450
          zmax=z2
          zmin=z1
  450     continue
          zmin=-zmax
          nndat0=nndata
          nndata=2*nndata-1
c read in 1st line of data: at the surface, or closest to the surface
c this subroutine is  a variation of sspeed.f, so 'speed' here is, really,
c buoyancy frequency, usually called 'n'.
              read (lfn,form) depth,speed
c depth converted to meters (if needed)
              zdata(nndat0)=zconv*depth
c buoyancy frequency converted to rad/hour
              ndata(nndat0)=nconv*speed
              itop=nndat0+1
              if(depth.eq.0.0) go to 444
              nndata=nndata+1
              zdata(nndat0+1)=zdata(nndat0)
              zdata(nndat0)=-depth*zconv
              ndata(nndat0+1)=ndata(nndat0)
              itop=itop+1
c constructing 'surface-reflected' profile:simmetric around the surface
c zmin=-zmax; ndata(-z)=ndata(z)
444        do 500 i=itop,nndata
              read (lfn,form) depth,speed
              j=nndata-i+1
              zdata(i)=zconv*depth
              zdata(j)=-zdata(i)
              ndata(i)=nconv*speed
  500         ndata(j)=ndata(i)
c
c     assign weights and smoothing parameter
c we have same smoothing parameter at all depths here. It can
c be changed (you might want to assign larger value to dyya(i)
c to close to surface  depths -'upper layer', where exprimental data is often
c non-smooth). Remember, that we have here 'surface-reflected' profile.
          do 505 i=1,nndata
  505         dyya(i)=dyy
c     calculate smoothed data points
          call smthn(1,nndata,zdata,ndata,dyya,sss,sdata,c1,c2,c3)
          zdata(1)=zmin
          zdata(nndata)=zmax
          iz=nndat0
          return
c
      entry bflist
          write(iuout,9000) bfname
 9000     format(
     *    a7,' buoyancy frequency profile parameters'/)
      write(iuout,9100) sss,dyy
 9100 format(
     *'sss       smoothing parameter           ',g12.5,'          '/
     *'dyy        std dev of data               ',g12.5,'          '/)
c
          return
          end
