      subroutine fss
c to calculate integral sum *SS* in eq.(A22-A23) of S.M.Flatte's and
c R.B.Stoughton 'Predictions of internal-wave effects on ocean acoustic
c coherence,...',1988. Read 'User's Guide to CAFI' for more information
c steps=number of stored steps for one double-loop
      integer steps
c a1n,b1n,etc are defined by eq.(A13-A15); a1n*-ab*, sa2n(), sb2n() etc. are
c various combinations of these coefficients used in the equations for
c fluctuation parameters
      real a1nsq,a2nsq,b1nsq(900),b2nsq(900),
     & ab1n(900),ab2n(900),sa1n(900),sa2n(900),sb1n(900),
     & sb2n(900),sc1n(900),sc2n(900)
c wtsq(),wst(),wssq() are integrals of w(u)*t(u)^2,etc. in eq.(A23)
      real wtsq(1000),wst(1000),wssq(1000)
      common/loops/nloops,itmin,rfrac
      common/rparm/rmax,steps,hstore,hlas
      common/ab/a1nsq,a2nsq,b1nsq,b2nsq,ab1n,ab2n,sa1n,sa2n,
     & sb1n,sb2n,sc1n,sc2n
      common/fcoef/fttnpr,fstnpr,fssnpr,fttn,fstn,fssn
      common/wints/wtsq,wst,wssq,wtsq0p,wst0p,wssq0p,loc
      sumss1=0.0
      sumss2=0.0
      sumss3=0.0
      sumss4=0.0
      sumss5=0.0
      sumss6=0.0
      sumss7=0.0
      sumss8=0.0
      sumss9=0.0
      fssnpr=0.
      fssn=0.
      if(nloops.eq.0) go to 99
      n1=nloops+1
      sumss2=sa2n(1)*b1nsq(1)
      sumss5=sc2n(1)*b1nsq(1)
      sumss8=sb2n(1)*b1nsq(1)
      if(nloops.eq.1) go to 30
      sumss3=(sa2n(1)-a2nsq)*b1nsq(1)
      sumss6=(sc2n(1)-ab2n(n1))*b1nsq(1)
      sumss9=(sb2n(1)-b2nsq(n1))*b1nsq(1)
c      print *,'in fss,i=1,sum3=',sumss3,'sum6=',sumss6,'s9=',sumss9
      do 20 i=2,nloops
      sumss1=sumss1+sa1n(i)*b2nsq(i)
      sumss4=sumss4+sc1n(i)*b2nsq(i)
      sumss7=sumss7+sb1n(i)*b2nsq(i)
      sumss2=sumss2+sa2n(i)*b1nsq(i)
      sumss5=sumss5+sc2n(i)*b1nsq(i)
      sumss8=sumss8+sb2n(i)*b1nsq(i)
c      print *,'fss,i=',i,'sum1=',sumss1,'sum4=',sumss4,'s7=',sumss7
c      print *,'fss,i=',i,'sum2=',sumss2,'sum5=',sumss5,'s8=',sumss8
      if(i.eq.nloops) go to 20
      sumss3=sumss3+(sa2n(i)-a2nsq)*b1nsq(i)
      sumss6=sumss6+(sc2n(i)-ab2n(n1))*b1nsq(i)
      sumss9=sumss9+(sb2n(i)-b2nsq(n1))*b1nsq(i)
c      print *,'fss,i=',i,'sum3=',sumss3,'sum6=',sumss6,'s9=',sumss9
20    continue
30    sss1n=sumss1+sa1n(n1)*b2nsq(n1)
      sss2n=sumss2
      sss3n=sumss3
      sss4n=sumss4+sc1n(n1)*b2nsq(n1)
      sss5n=sumss5
      sss6n=sumss6
      sss7n=sumss7+sb1n(n1)*b2nsq(n1)
      sss8n=sumss8
      sss9n=sumss9
c      print *,'fss,i=',i,'sum1=',sumss1,'sum4=',sumss4,'s7=',sumss7
c      print *,'fss,i=',i,'sum3=',sumss3,'sum6=',sumss6,'s9=',sumss9
c      print *,'fss,i=',i,'sum2=',sumss2,'sum5=',sumss5,'s8=',sumss8
      fssnpr=sumss1*wssq(steps)+sumss2*wssq0p+sumss3*(wssq(steps)-
     & wssq0p)+2.0*sumss4*wst(steps)+2.0*sumss5*wst0p+2.0*sumss6*
     & (wst(steps)-wst0p)+sumss7*wtsq(steps)+sumss8*wtsq0p+
     & sumss9*(wtsq(steps)-wtsq0p)
      fssn=sss1n*wssq(steps)+sss2n*wssq0p+sss3n*(wssq(steps)-
     & wssq0p)+2.0*sss4n*wst(steps)+2.0*sss5n*wst0p+2.0*sss6n*
     & (wst(steps)-wst0p)+sss7n*wtsq(steps)+sss8n*wtsq0p+
     & sss9n*(wtsq(steps)-wtsq0p)
99    return
      end
