      subroutine fst
c to calculate integral sum *ST* in eq.(A22-A23) of S.M.Flatte's and
c R.B.Stoughton 'Predictions of internal-wave effects on ocean acoustic
c coherence,...',1988. Read 'User's Guide to CAFI' for more information
c steps=number of stored steps for one double-loop
      integer steps
c a1n,b1n,etc are defined by eq.(A13-A15); a1n*-ab*, sa2n(), sb2n() etc. are
c various combinations of these coefficients used in the equations for
c fluctuation parameters
      real a1nsq,a2nsq,b1nsq(900),b2nsq(900),
     & ab1n(900),ab2n(900),sa1n(900),sa2n(900),sb1n(900),
     & sb2n(900),sc1n(900),sc2n(900)
c wtsq(),wst(),wssq() are integrals of w(u)*t(u)^2,etc. in eq.(A23)
      real wtsq(1000),wst(1000),wssq(1000)
      common/loops/nloops,itmin,rfrac
      common/rparm/rmax,steps,hstore,hlas
      common/ab/a1nsq,a2nsq,b1nsq,b2nsq,ab1n,ab2n,sa1n,sa2n,
     & sb1n,sb2n,sc1n,sc2n
      common/sumst/sumst1,sumst2,sumst3,sumst4,sumst5,sumst6,sumst7
     &,sumst8,sumst9
      common/sumstn/sstn1,sstn2,sstn3,sstn4,sstn5,sstn6,sstn7
     &,sstn8,sstn9
      common/fcoef/fttnpr,fstnpr,fssnpr,fttn,fstn,fssn
      common/wints/wtsq,wst,wssq,wtsq0p,wst0p,wssq0p,loc
      n1=nloops+1
      sumst1=0.0
      sumst2=0.0
      sumst3=0.0
      sumst4=0.0
      sumst5=0.0
      sumst6=0.0
      sumst7=0.0
      sumst8=0.0
      sumst9=0.0
      fstnpr=0.
      fstn=0.
      if(nloops.eq.0) go to 99
      sumst2=sa2n(1)*ab1n(1)
      sumst5=sc2n(1)*ab1n(1)
      sumst8=sb2n(1)*ab1n(1)
      if(nloops.eq.1) go to 30
      sumst3=(sa2n(1)-a2nsq)*ab1n(1)
      sumst6=(sc2n(1)-ab2n(n1))*ab1n(1)
      sumst9=(sb2n(1)-b2nsq(n1))*ab1n(1)
      do 20 i=2,nloops
      sumst1=sumst1+sa1n(i)*ab2n(i)
      sumst4=sumst4+sc1n(i)*ab2n(i)
      sumst7=sumst7+sb1n(i)*ab2n(i)
      sumst2=sumst2+sa2n(i)*ab1n(i)
      sumst5=sumst5+sc2n(i)*ab1n(i)
      sumst8=sumst8+sb2n(i)*ab1n(i)
      if(i.eq.nloops) go to 30
      sumst3=sumst3+(sa2n(i)-a2nsq)*ab1n(i)
      sumst6=sumst6+(sc2n(i)-ab2n(n1))*ab1n(i)
      sumst9=sumst9+(sb2n(i)-b2nsq(n1))*ab1n(i)
20    continue
30    continue
      sst1n=sumst1+sa1n(n1)*ab2n(n1)
      sst2n=sumst2
      sst3n=sumst3
      sst4n=sumst4+sc1n(n1)*ab2n(n1)
      sst5n=sumst5
      sst6n=sumst6
      sst7n=sumst7+sb1n(n1)*ab2n(n1)
      sst8n=sumst8
      sst9n=sumst9
      fstnpr=sumst1*wssq(steps)+sumst2*wssq0p+sumst3*(wssq(steps)-
     & wssq0p)+2.0*sumst4*wst(steps)+2.0*sumst5*wst0p+2.0*sumst6*
     & (wst(steps)-wst0p)+sumst7*wtsq(steps)+sumst8*wtsq0p+sumst9*
     & (wtsq(steps)-wtsq0p)
      fstn=sst1n*wssq(steps)+sst2n*wssq0p+sst3n*(wssq(steps)-
     & wssq0p)+2.0*sst4n*wst(steps)+2.0*sst5n*wst0p+2.0*sst6n*
     & (wst(steps)-wst0p)+sst7n*wtsq(steps)+sst8n*wtsq0p+sst9n*
     & (wtsq(steps)-wtsq0p)
99      return
      end
