      subroutine gmray(a,theta,ampl,n1,na,m,jj,geom,nga)
c part of WKBJ Michael Brown's program
c
c     geom(i,1) - travel time
c     geom(i,2) - source angle
c     geom(i,3) - receiver angle
c     geom(i,4) - identifier
c     geom(i,5) - upper turn
c     geom(i,6) - lower turn
c     geom(i,7) - turning speed
c     geom(i,8) - relative amplitude
c
      dimension a(10000),theta(10000),geom(300,8)
      dimension zt(10000),zb(10000),ampl(10000)
      common/one/zt,zb,zs,zr,rindxs,rindxr,cmin,dpth
      common/seven/tstart,tend,nt,pltlen,rng
      dela=a(n1+1)-a(n1)
      d2=theta(n1+1)-theta(n1)
      nfirst=n1+1
      nlast=na-1
      do 5 i=nfirst,nlast
      d1=d2
      d2=theta(i+1)-theta(i)
      if(d1.ne.0.)go to 6
      l=i
4     l=l-1
      if(l.eq.n1)go to 11
      d1=theta(l)-theta(l-1)
      if(d1.ne.0.)go to 6
      go to 4
6     ratio=d2/d1
      if(i.eq.nlast.and.ratio.eq.0.)go to 11
      if(ratio.ge.0.)go to 5
11    nga=nga+1
      if(nga.gt.300)write(6,1010)
1010  format('nga.gt.300')
      ampltd=abs(ampl(i))
      th13=theta(i-1)-theta(i+1)
      th123=theta(i-1)-2.*theta(i)+theta(i+1)
      if(th123.eq.0.)go to 18
      isign=-int(sign(1.,th123))
      ao=a(i)+.5*dela*th13/th123
      geom(nga,1)=theta(i)-(th13**2)/(8.*th123)
      go to 19
18    isign=int(sign(1.,d1))
      ao=a(i)
      geom(nga,1)=theta(i)
c
c  find relative intensity, geom(nga,8) (=aright-aleft)
19    ta=theta(i)-float(isign)*.001
      tb=theta(i)+float(isign)*.001
c  find aleft
      aleft=a(n1)
      in1=i-n1
      do 25 j=1,in1
      tl=theta(i-j)
      tr=theta(i-j+1)
      if(isign.eq.-1.and.tl.lt.tb)go to 24
      if(isign.eq.-1.and.tl.lt.ta)go to 25
      if(isign.eq.1.and.tl.gt.tb)go to 24
      if(isign.eq.1.and.tl.gt.ta)go to 25
      aleft=a(i-j)+dela*(ta-tl)/(tr-tl)
      go to 30
24    aleft=a(i-j+1)
      go to 30
25    continue
c  find aright
30    aright=a(na)
      nai=na-i
      do 35 j=1,nai
      tl=theta(i+j-1)
      tr=theta(i+j)
      if(isign.eq.-1.and.tr.lt.tb)go to 34
      if(isign.eq.-1.and.tr.lt.ta)go to 35
      if(isign.eq.1.and.tr.gt.tb)go to 34
      if(isign.eq.1.and.tr.gt.ta)go to 35
      aright=a(i+j-1)+dela*(ta-tl)/(tr-tl)
      go to 40
34    aright=a(i+j-1)
      go to 40
35    continue
40    geom(nga,8)=50.*ampltd*(aright-aleft)
      if(aright.ge.aleft)go to 20
c      write(6,1001)
1001  format(17hgeom(nga,8).lt.0.)
      stop
20    if(ao.gt.a(i))go to 16
      delta=(ao-a(i-1))/dela
      zup=zt(i-1)+delta*(zt(i)-zt(i-1))
      zdown=zb(i-1)+delta*(zb(i)-zb(i-1))
      go to 41
16    delta=(ao-a(i))/dela
      zup=zt(i)+delta*(zt(i+1)-zt(i))
      zdown=zb(i)+delta*(zb(i+1)-zb(i))
41    dpr=57.29578
c      axa=arcos(ao)*dpr
      sa=arcos(ao/rindxs)*dpr
      ra=arcos(ao/rindxr)*dpr
      if(jj.ne.1.and.jj.ne.5.and.jj.ne.9)go to 12
      nturn=2*(m-1)
      if(zr.lt.zs)go to 10
      nturn=-nturn
      sa=-sa
      ra=-ra
      go to 10
12    if(jj.ne.2.and.jj.ne.6.and.jj.ne.10)go to 13
      nturn=2*m
      if(zr.ge.zs)go to 10
      nturn=-nturn
      sa=-sa
      ra=-ra
      go to 10
13    if(jj.ne.3.and.jj.ne.7.and.jj.ne.11)go to 14
      nturn=2*m-1
      ra=-ra
      go to 10
14    nturn=-(2*m-1)
      sa=-sa
10    speed=cmin/a(i)
c      write(4,1000)geom(nga,1),sa,ra,ao,nturn,isign,zup,zdown,speed,
c     .geom(nga,8),m,jj
1000  format(f11.4,1x,2(f7.3,1x),f7.5,2i5,2f8.0,f10.2,f8.3,i4,i3)
      geom(nga,2)=sa
      geom(nga,3)=ra
      geom(nga,4)=float(nturn)
      geom(nga,5)=zup
      geom(nga,6)=zdown
      geom(nga,7)=speed
2000  format(f8.4,1x,f6.5,2i3)
5     continue
      return
      end
