      subroutine nngral(rfrac)
      integer steps
      real dlama1(1000),dlama2(1000),dlama3(1000),dkvsq(1000)
     &,dtt(1000),dnupsq(1000),dkhl(1000)
      real zdl(1000),tdl(1000),ttdl(1000),s2bdl(1000),bfdl(1000)
     &,pwtdl(1000),psqidl(1000),pdwt(1000),pdidl(1000)
     &,qkv(1000),qkvsq(1000)
      real wtsq(1000),wst(1000),wssq(1000)
      common/rparm/rmax,steps,hstore,hlas
      common/rayst/zdl,tdl,ttdl,s2bdl,bfdl,pwtdl,psqidl,pdwt,pdidl
     &,qkv,qkvsq
      common/rayst2/dlama1,dlama2,dlama3,dkvsq,dtt,dnupsq,dkhl
      common/wints/wtsq,wst,wssq,wtsq0p,wst0p,wssq0p,loc
c
c dkvsq(i) is a weighting function w(x) in S.M.Flatte and R.B. Stoughton
c 'Predictions of internal-wave effects on ocean acoustic coherence...',1988.
c 
c tabulating integrals at each step for double-loop length
c wtsq(i)=Integral(w(x)*t(x)^2)dx; wst(i)=Integral(w(x)*t(x)*s(x))dx
c as in eq.(A4)
      wtsq(1)=(dkvsq(1)*hstore)*(tdl(1)**2)
      wst(1)=(dkvsq(1)*hstore)*(tdl(1)*s2bdl(1))
      wssq(1)=(dkvsq(1)*hstore)*(s2bdl(1)**2)
      do 99 j=2,steps-2
c      print *,j,'z',zdl(j),'w',dkvsq(j),'t',tdl(j),'s',s2bdl(j)
      wtsq(j)=wtsq(j-1)+(dkvsq(j)*hstore)*(tdl(j)**2)
      wst(j)=wst(j-1)+(dkvsq(j)*hstore)*(tdl(j)*s2bdl(j))
      wssq(j)=wssq(j-1)+(dkvsq(j)*hstore)*(s2bdl(j)**2)
c      print *,j,wtsq(j),wst(j),wssq(j)
99    continue
      j=steps-1
c      print *,'hstore=',hstore,'rmax=',rmax
      wtsq(j)=wtsq(j-1)+(dkvsq(j)*hlas)*(tdl(j)**2)
      wst(j)=wst(j-1)+(dkvsq(j)*hlas)*(tdl(j)*s2bdl(j))
      wssq(j)=wssq(j-1)+(dkvsq(j)*hlas)*(s2bdl(j)**2)
c      print *,j,wtsq(j),wst(j),wssq(j)
c
c      These integrals *(steps) are used in tau0 and some other
c  calculations, there should be instead *(steps-1)
      wtsq(steps)=wtsq(steps-1)
      wst(steps)=wst(steps-1)
      wssq(steps)=wssq(steps-1)
c
      loc=rfrac/hstore+1
      hfrac=rfrac-(loc-1)*hstore
      if(rfrac.le.hstore) hfrac=rfrac
      frach1=hfrac/hstore
      if(loc.eq.steps-1) frach1=hfrac/hlas
      frach2=1.0-frach1
      l1=loc+1
      if(loc.eq.steps) l1=2
      t0p=frach1*tdl(l1)+frach2*tdl(loc)
      s0p=frach1*s2bdl(l1)+frach2*s2bdl(loc)
      dkvsq0=frach1*dkvsq(l1)+frach2*dkvsq(loc)
      wtsq0p=wtsq(loc)+t0p*t0p*hfrac*dkvsq0
      wst0p=wst(loc)+t0p*s0p*hfrac*dkvsq0
      wssq0p=wssq(loc)+s0p*s0p*hfrac*dkvsq0
c      print *,'loc',loc,'hfrac',hfrac,'t(loc)',tdl(loc),t0p,tdl(loc+1)
c      print *,'wtsq0p,wst0p,wssq0p'
c      print *,wtsq0p,wst0p,wssq0p
      return
      end
