      function phint(a,zupr,zlwr)
c  this function evaluates phase integrals of the form $sqrt(n**2-a**2)dz
c  by assuming n**2=a+bz between points in the model
      dimension rindx(1601)
      common/two/rindx,dz
      nupr=int(zupr/dz)+2
      nlwr=int(zlwr/dz)+1
      phint=0.
      if(zlwr.gt.zupr)go to 1
      return
1     a2=a**2
      r2=rindx(nupr-1)**2
      rn2=rindx(nupr)**2
      b=(r2-rn2)/dz
      delz=zupr-dz*float(nupr-2)
      r2=r2-b*delz
      q=0.
      if(r2.gt.a2)q=sqrt(r2-a2)
      top=q**3
      if(nupr.gt.nlwr)r2=rindx(nupr-1)**2
      if(nupr.gt.nlwr)go to 7
      q=0.
      if(rn2.gt.a2)q=sqrt(rn2-a2)
      bot=q**3
      if(q.ne.0.)eps=dz*b/q**2
      if(q.ne.0..and.abs(eps).lt.1.e-2)go to 11
      phint=(top-bot)/b
      go to 12
11    phint=q*(dz-delz)*1.5*(1.+eps/4.-(eps**2)/24.+(eps**3)/64.)
12    if(nupr.eq.nlwr)go to 6
      nlwr1=nlwr-1
      do 5 i=nupr,nlwr1
      r2=rn2
      rn2=rindx(i+1)**2
      b=(r2-rn2)/dz
      top=bot
      q=0.
      if(rn2.gt.a2)q=sqrt(rn2-a2)
      bot=q**3
      if(q.ne.0.)eps=dz*b/q**2
      if(q.ne.0..and.abs(eps).lt.1.e-2)go to 10
      phint=phint+(top-bot)/b
      go to 5
10    phint=phint+q*dz*1.5*(1.+eps/4.-(eps**2)/24.+(eps**3)/64.)
5     continue
6     r2=rn2
      rn2=rindx(nlwr+1)**2
      b=(r2-rn2)/dz
      top=bot
7     delz=zlwr-dz*float(nlwr-1)
      rn2=r2-b*delz
      q=0.
      if(rn2.gt.a2)q=sqrt(rn2-a2)
      bot=q**3
      if(q.ne.0.)eps=dz*b/q**2
      if(q.ne.0..and.abs(eps).lt.1.e-2)go to 13
      phint=phint+(top-bot)/b
      go to 14
13    phint=phint+q*delz*1.5*(1.+eps/4.-(eps**2)/24.+(eps**3)/64.)
14    continue
      phint=2.*phint/3.
      return
      end
